/* Program sparen
   Berechnet Zins, Zuwachs und Guthaben bei Sparvertraegen */

/*
    Copyright (C) 2008  Juergen Kaesmann (JK)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* ======================================================================== */
/*		Die Standard-Bibliothek
#include <assert.h>		Fehlersuche
#include <ctype.h>		Tests fuer Zeichenklassen
#include <errno.h>
#include <float.h>		Grenzwerte einer Implementierung
#include <limits.h>		Grenzwerte einer Implementierung
#include <locale.h>
#include <math.h>		Mathematische Funktionen
#include <setjmp.h>		Globale Spruenge
#include <signal.h>		Signale
#include <stdarg.h>		Variable Argumentlisten
#include <stddef.h>             in /usr/include/linux/
#include <stdio.h>		Ein- und Ausgabe
#include <stdlib.h>		Hilfsfunktionen
#include <string.h>		Funktionen fuer Zeichenketten
#include <time.h>		Funktionen fuer Datum und Uhrzeit
*/

#include <stdio.h>		/* Ein- und Ausgabe */
#include <stdlib.h>		/* Hilfsfunktionen */

#define DEBUGno
#define DEBUG1no
#define DEBUG2no

/* ======================================================================== */
main(int argc, char *argv[])
{
  int jahr = 0;
  int mon  = 0;
  int laufzeit;
  double rate;
  double zinssatz;
  double zins    = 0;
  double zinssum = 0;
  double sparsum = 0;
  double kapital = 0;
  char *prog = argv[0];                /* programmname fuer fehlermeldungen */
  
#ifdef DEBUG
  printf("main:\n");
#endif

  if ((argc > 1) && strcmp(argv[1], "-h") == 0)      /* parameter angegeben */
  {
    printf("Format: sparen -h | Zinssatz Sparrate Mon [SGut]\n");
    printf("-h       = Diese Hilfe\n");
    printf("Zinssatz = Zinssatz in Prozent\n");
    printf("Sparrate = Sparrate\n");
    printf("Mon      = Anzahl der Monate\n");
    printf("SGut     = Startguthaben\n");
    printf("\n");
    printf("Berechnet Zins, Zinssumme, Sparsumme und Guthaben\n");
    exit(0);
  }

  if (argc < 4)                                  /* weniger als 3 parameter */
  {
    printf("Error - missing parameters!\n");
    exit(1);
  }

  if (argc >= 4)                                 /* mind. 3 parameter */
  {
    zinssatz = atof(argv[1]);
    rate     = atof(argv[2]);
    laufzeit = atoi(argv[3]);
  }

  if (argc >= 5)                                 /* mind. 4 parameter */
    kapital = atof(argv[4]);

  if (argc > 5)                                  /* mehr als 4 parameter */
  {
    printf("Error - too many parameters!\n");
    exit(1);
  }

  printf("ZINSSATZ: %5.2f% | SPARRATE:%9.2f | STARTGUTHABEN:%12.2f\n\n",
         zinssatz, rate, kapital);
  printf("JAHR  MON         ZINS    ZINSSUMME    SPARSUMME     GUTHABEN\n");

  while (mon < laufzeit)
  {
    mon     = mon + 1;
    kapital = kapital + rate;
    zins    = kapital / 100 * zinssatz / 12;
    zinssum = zinssum + zins;
    sparsum = sparsum + rate;
    kapital = kapital + zins;
    
    if ((mon % 12) == 0)
    {
      jahr = jahr + 1;
      printf("%4i ", jahr);
    }
    else
      printf("     ");
    printf("%4i %12.2f %12.2f %12.2f %12.2f\n",
           mon, zins, zinssum, sparsum, kapital);
  }
}
